<?php

require('includes/application_top.php');

$cwd = getcwd();
chdir('../');
require('includes/languages/english/modules/payment/windcave.php');
require('ext/modules/payment/windcave/constants.php');
require('ext/modules/payment/windcave/classes/windcave_logger.php');
require('ext/modules/payment/windcave/classes/windcave_entity.php');
require('ext/modules/payment/windcave/classes/windcave_transaction.php');

$logger = new windcaveLogger(MODULE_PAYMENT_WINDCAVE_DIR_LOG);
chdir($cwd);

$action = isset($HTTP_GET_VARS['action']) ? $HTTP_GET_VARS['action'] : '';

$bar = isset($HTTP_GET_VARS['bar']) ? $HTTP_GET_VARS['bar'] : false;

$page = isset($HTTP_GET_VARS['page']) ? $HTTP_GET_VARS['page'] : false;

$transaction_id = isset($HTTP_GET_VARS['txn_select']) ? $HTTP_GET_VARS['txn_select'] : false;

$result = "";

switch ($action) {
  case 'refund':
    $refund_remaining = isset($HTTP_GET_VARS['refund_remaining']) ? ($HTTP_GET_VARS['refund_remaining'] == "true") : false;
    $refund_total = isset($HTTP_POST_VARS['refund_total']) ? $HTTP_POST_VARS['refund_total'] : false;
    $result = refund($transaction_id, $logger, $refund_remaining, $refund_total);
    $bar = implode("*", $result);
    tep_redirect(tep_href_link('windcave.php', 'bar=' . $bar . '&txn_select=' . $transaction_id . '&page=' . $page . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'] . '&search_deleted=' . $search_deleted));
    break;
  case 'complete':
    $result = complete($transaction_id, $logger);
    $bar = implode("*", $result);
    tep_redirect(tep_href_link('windcave.php', 'bar=' . $bar . '&txn_select=' . $transaction_id . '&page=' . $page . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'] . '&search_deleted=' . $search_deleted));
    break;
  case 'void':
    $result = void($transaction_id, $logger);
    $bar = implode("*", $result);
    tep_redirect(tep_href_link('windcave.php', 'bar=' . $bar . '&txn_select=' . $transaction_id . '&page=' . $page . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'] . '&search_deleted=' . $search_deleted));
    break;
  case 'retry_refund':
  case 'retry_complete':
  case 'retry_void':
    $retry_type = str_replace('retry_', '', $action);
    $query = tep_db_query("select * from windcave_transaction where transaction_id ='" . $transaction_id . "' limit 1");
    if ($query->num_rows > 0) {
      $old_transaction = tep_db_fetch_array($query);
      $logger->addLog("attempting to requery the $action for this transaction', 'transaction", $transaction_id);
      $result = retry($old_transaction, $retry_type, $logger);
      if ($result['success']) {
        $result['message'] = 'Transaction ' . $retry_type . 'ed successfully';
      } else {
        if ($result['message'] == '') {
          $result['message'] = ucfirst($retry_type) . ' failed';
        } else {
          $result['message'] = ucfirst($retry_type) . ' failed - ' . $result['message'];
        }
      }
    } else {
      $logger->addLog('Error - could not find transaction to retry');
      $result = array(
        'success' => false,
        'message' => 'Error - could not find transaction to retry'
      );
    }
    $bar = implode("*", $result);
    tep_redirect(tep_href_link('windcave.php', 'bar=' . $bar . '&txn_select=' . $transaction_id . '&page=' . $page . '&search_deleted=' . $search_deleted . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID']));
    break;
}

$query_suffix = '';

if (isset($HTTP_GET_VARS['oID']) && ($HTTP_GET_VARS['oID'] != '')) {
  $query_suffix = " and order_id = '" . $HTTP_GET_VARS['oID'] . "'";
}
if (isset($HTTP_GET_VARS['cID']) && ($HTTP_GET_VARS['cID'] != '')) {
  $query_suffix = $query_suffix .  " and customer_id = '" . $HTTP_GET_VARS['cID'] . "'";
}

$search_deleted = isset($HTTP_GET_VARS['search_deleted']) ? ($HTTP_GET_VARS['search_deleted'] == "1") : false;

if (!$search_deleted) {
  $transactions_query_raw = "select * from windcave_transaction where transaction_id != ''" . $query_suffix . " order by order_id desc";
} else {
  $transactions_query_raw = "select windcave_transaction.* from windcave_transaction left join " . TABLE_ORDERS . " on windcave_transaction.order_id = " . TABLE_ORDERS . ".orders_id where " . TABLE_ORDERS . ".orders_id is null and windcave_transaction.outstanding = '" . true . "' and windcave_transaction.transaction_id != '' order by order_id desc";
}

$transactions_split = new splitPageResults($HTTP_GET_VARS['page'], MAX_DISPLAY_SEARCH_RESULTS, $transactions_query_raw, $transactions_query_numrows);
$transactions_query = tep_db_query($transactions_query_raw);

require(DIR_WS_INCLUDES . 'template_top.php');
?>
<table border="0" width="100%" cellspacing="0" cellpadding="2">
  <tr>
    <td width="100%">
      <table border="0" width="100%" cellspacing="0" cellpadding="0">
        <tr>
          <td class="pageHeading">Windcave Transactions</td>
          <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
          <td align="right">
            <table border="0" width="25%" cellspacing="0" cellpadding="0">
              <form action="<?php echo (tep_href_link('windcave.php', 'txn_select=' . $transaction_id . '&page=' . $page . '&search_deleted=' . $search_deleted . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'])) ?>" method="get">
                <tr>
                  <td class="smallText" align="right"><?php echo 'Order ID ' . tep_draw_input_field('oID', '', 'size="12"') ?></td>
                  <td>&nbsp;</td>
                  <td class="smallText" align="right"><?php echo 'Customer ID ' . tep_draw_input_field('cID', '', 'size="12"') ?></td>
                  <td>&nbsp;</td>
                  <td align="right" valign="bottom"><?php echo (tep_draw_button('Search', '')); ?></td>
                </tr>
                <?php echo tep_hide_session_id(); ?>
              </form>
            </table>
        </tr>
        <tr>
          <td>&nbsp;</td>
          <td>&nbsp;</td>
          <td align="right" valign="bottom"><?php echo (tep_draw_button('View Outstanding Deleted Orders', '', tep_href_link('windcave.php', 'search_deleted=1'))); ?></td>
        </tr>
      </table>
    </td>
  </tr>
  <?php
  if ($bar != false) {
    $bar_success = explode('*', $bar)[0];
    $message = explode('*', $bar)[1];
    if ($bar_success == '1') {
  ?>
      <tr>
        <td class="messageStackSuccess"><?php echo ($message); ?></td>
      </tr>
    <?php
    } else {
    ?>
      <tr>
        <td class="messageStackWarning"><?php echo ($message); ?></td>
      </tr>
  <?php
    }
  }
  ?>
  <tr>
    <td>
      <table border="0" width="100%" cellspacing="0" cellpadding="0">
        <tr>
          <td valign="top">
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr class="dataTableHeadingRow">
                <td class="dataTableHeadingContent">Order ID</td>
                <td class="dataTableHeadingContent">Customer ID</td>
                <td class="dataTableHeadingContent">Customer Name</td>
                <td class="dataTableHeadingContent">Transaction Type</td>
                <td class="dataTableHeadingContent">Transaction ID</td>
                <td class="dataTableHeadingContent">Parent Transaction ID</td>
                <td class="dataTableHeadingContent">Windcave Status</td>
                <td class="dataTableHeadingContent">Order Status</td>
                <td class="dataTableHeadingContent">Total</td>
                <td class="dataTableHeadingContent">Date Added</td>
                &nbsp;
              </tr>

              <?php
              $prev_order_id = "none";
              $row_over = false;
              $txn_not_set = ($transaction_id == false);
              while ($transaction = tep_db_fetch_array($transactions_query)) {
                if ($txn_not_set && $transaction['transaction_id'] != '') {
                  $transaction_id = $transaction['transaction_id'];
                  $txn_not_set = false;
                }
                $transaction = prepareTransaction($transaction);
                $order = prepareOrder($transaction);
                $show_order = true;
                if ($search_deleted && $order['inactive'] == true) {
                  $show_order = false;
                }
                if ($show_order) {
                  if ($prev_order_id != $transaction['order_id']) {
                    $prev_order_id = $transaction['order_id'];
                    $row_over = !$row_over;
                  }
                  if ($transaction['transaction_id'] == $transaction_id) {
              ?>
                    <tr class="dataTableRowSelected">
                      <?php
                    } else {
                      if (!$row_over) {
                      ?>
                    <tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href='<?php echo (tep_href_link('windcave.php', 'txn_select=' . $transaction['transaction_id'] . '&search_deleted=' . $search_deleted . '&page=' . $page . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'])); ?>'">
                    <?php
                      } else {
                    ?>
                    <tr class="dataTableRowOut" onmouseover="rowOutEffect(this)" onmouseout="rowOverEffect(this)" onclick="document.location.href='<?php echo (tep_href_link('windcave.php', 'txn_select=' . $transaction['transaction_id'] . '&search_deleted=' . $search_deleted . '&page=' . $page . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'])); ?>'">
                  <?php
                      }
                    }
                  ?>
                  <td class="dataTableContent" align="left"><?php echo ($order['orders_id']); ?></td>
                  <td class="dataTableContent" align="left"><?php echo ($transaction['customer_id']); ?></td>
                  <td class="dataTableContent" align="left"><?php echo ($order['customers_name']); ?></td>
                  <td class="dataTableContent"><?php echo (ucfirst($transaction['transaction_type'])); ?></td>
                  <td class="dataTableContent"><?php echo ($transaction['transaction_id']); ?></td>
                  <td class="dataTableContent"><?php echo ($transaction['parent_transaction_id']); ?></td>
                  <td class="dataTableContent"><?php echo ($transaction['status']); ?></td>
                  <td class="dataTableContent"><?php echo ($order['orders_status']); ?></td>
                  <td class="dataTableContent"><?php echo ($transaction['amount']); ?></td>
                  <td class="dataTableContent"><?php echo (tep_datetime_short($transaction['date_added'])); ?></td>
                  &nbsp;
                    </tr>
                <?php
                }
              }
                ?>
          </td>
        </tr>
        <tr>
          <td colspan="5">
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td class="smallText" valign="top"><?php echo $transactions_split->display_count($transactions_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, $HTTP_GET_VARS['page'], MODULE_PAYMENT_WINDCAVE_TEXT_DISPLAY_NUMBER_OF_TRANSACTIONS); ?></td>
                <td class="smallText" align="right"><?php echo $transactions_split->display_links($transactions_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, MAX_DISPLAY_PAGE_LINKS, $HTTP_GET_VARS['page'], tep_get_all_get_params(array('page', 'oID', 'cID', 'txn_select', 'action'))); ?></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
    <td valign="top">
      <form id="form-transaction" method="post" action="<?php echo (tep_href_link('windcave.php', 'txn_select=' . $transaction_id . '&oID=' . $HTTP_GET_VARS['oID'] . '&cID=' . $HTTP_GET_VARS['cID'] . '&search_deleted=' . $search_deleted)); ?>">
        </br>
        <?php
        if ($transaction_id != false) {
          $transaction = prepareTransaction(tep_db_fetch_array(tep_db_query("select * from windcave_transaction where transaction_id = '" . $transaction_id . "' limit 1")));

          $heading = array();
          $contents = array();

          $heading[] = array('text' => '<strong>Transaction ID: ' . $transaction_id . '</strong>');

          $contents[] = array('text' => '<table border="0" cellspacing="0" cellpadding="0">');

          $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Order ID:</strong> ' . $transaction['order_id'] . '</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Transaction Type:</strong> ' . ucfirst($transaction['transaction_type']) . '</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Total:</strong> ' . $transaction['amount'] . '</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Windcave status:</strong> ' . $transaction['status'] . '</td></tr>');
          $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          if ($transaction['auth_complete_status'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Auth complete status:</strong> ' . $transaction['auth_complete_status'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['void_status'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Void status:</strong> ' . $transaction['void_status'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['refund_status'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Refund status:</strong> ' . $transaction['refund_status'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['cardholder_name'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Card holder name:</strong> ' . $transaction['cardholder_name'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['card_mask'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Card number (masked):</strong> ' . $transaction['card_mask'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['expiry_date_month'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Expiry date:</strong> ' . $transaction['expiry_date_month'] . '/' . $transaction['expiry_date_year'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['card_type'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Card type:</strong> ' . $transaction['card_type'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['response_code'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Response code:</strong> ' . $transaction['response_code'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['response_text'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Response text:</strong> ' . $transaction['response_text'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['payment_method'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Payment method:</strong> ' . ucfirst($transaction['payment_method']) . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['payment_authentication'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Payment authentication:</strong> ' . ucfirst($transaction['payment_authentication']) . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['auth_code'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Auth code:</strong> ' . $transaction['auth_code'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['avs_action'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>AVS action:</strong> ' . $transaction['avs_action'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['cv2_result'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>AVS result:</strong> ' . $transaction['cv2_result'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['risk_action'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Risk action:</strong> ' . $transaction['risk_action'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['risk_summary_text'] != "") {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Risk summary text:</strong> ' . $transaction['risk_summary_text'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
          }
          if ($transaction['transaction_type'] == 'auth' && $transaction['status'] == 'Approved') {
            if ($transaction['auth_complete_status'] == 'Not completed' && $transaction['void_status'] == 'Not voided') {
              $contents[] = array('text' => tep_draw_button('Complete', '', null, null, array('params' => 'onclick="buttonClick(' . "'complete'" . ');"')));
              $contents[] = array('text' => tep_draw_button('Void', '', null, null, array('params' => 'onclick="buttonClick(' . "'void'" . ');"')));
            } elseif ($transaction['auth_complete_status'] == 'Processing') {
              $contents[] = array('text' => tep_draw_button('Retry complete', '', null, null, array('params' => 'onclick="buttonClick(' . "'retry_complete'" . ');"')));
            } elseif ($transaction['void_status'] == 'Voiding') {
              $contents[] = array('text' => tep_draw_button('Retry void', '', null, null, array('params' => 'onclick="buttonClick(' . "'retry_void'" . ');"')));
            }
          }
          if (($transaction['transaction_type'] == 'purchase' || $transaction['transaction_type'] == 'complete') && ($transaction['status'] == 'Approved')) {
            if ($transaction['refund_status'] == 'Not refunded') {
              $contents[] = array('text' => tep_draw_input_field('refund_total', '', 'size="12"') . tep_draw_button('Partial refund', '', null, null, array('params' => 'onclick="buttonClick(' . "'refund'" . ');"')));
              $contents[] = array('text' => tep_draw_button('Refund', '', null, null, array('params' => 'onclick="buttonClick(' . "'refund&refund_remaining=true'" . ');"')));
            } elseif ($transaction['refund_status'] == 'Refunding') {
              $contents[] = array('text' => tep_draw_button('Retry refund', '', null, null, array('params' => 'onclick="buttonClick(' . "'retry_refund'" . ');"')));
            }
          }
          $contents[] = array('text' => tep_draw_button('View all transactions for this order', '', tep_href_link('windcave.php', '&oID=' . $transaction['order_id'] . '&search_deleted=' . $search_deleted)));


          $contents[] = array('text' => '</table>');

          $transaction_box = new box();
          echo ($transaction_box->infoBox($heading, $contents));


          $order = prepareOrder($transaction);
          $heading = array();
          $contents = array();

          $heading[] = array('text' => '<strong>Order ID: ' . $order['orders_id'] . '</strong>');

          $contents[] = array('text' => '<table border="0" cellspacing="0" cellpadding="0">');

          if ($order['deleted'] == false) {
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Customer ID:</strong> ' . $order['customers_id'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Customer Name:</strong> ' . $order['customers_name'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Order status:</strong> ' . $order['orders_status'] . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
            $products_table = prepareProducts($transaction);
            $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Order products:</strong> ' . $products_table . '</td></tr>');
            $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
            $contents[] = array('text' => tep_draw_button('View order', '', tep_href_link('orders.php', 'action=edit&oID=' . $order['orders_id'] . '&search_deleted=' . $search_deleted)));
          } else {
            if ($transaction['outstanding'] == "1") {
              $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>This order has been deleted, but still has active transactions</strong></td></tr>');
              $contents[] = array('text' => '<tr><td class="dataTableContent">&nbsp;</td></tr>');
              $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>Please refund/void all transactions associated with this order</strong></td></tr>');
            } else {
              $contents[] = array('text' => '<tr><td class="dataTableContent"><strong>This order has been deleted</strong></td></tr>');
            }
          }
          $contents[] = array('text' => '</table>');

          $order_box = new box();
          echo ($order_box->infoBox($heading, $contents));
        }
        ?>
      </form>
    </td>
  </tr>
  </td>
  </tr>
</table>
<?php
require(DIR_WS_INCLUDES . 'template_bottom.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');

function prepareTransaction($transaction)
{
  $status = '';
  switch ($transaction['status']) {
    case PROCESSING_STATUS_WINDCAVE:
      $status = 'Processing';
      break;
    case APPROVED_STATUS_WINDCAVE:
      $status = 'Approved';
      break;
    case DECLINED_STATUS_WINDCAVE:
      $status = 'Declined';
      break;
    case REFUNDED_STATUS_WINDCAVE:
      $status = 'Refunded';
      break;
    case VOIDED_STATUS_WINDCAVE:
      $status = 'Voided';
      break;
    case CANCELLED_STATUS_WINDCAVE:
      $status = 'Cancelled';
      break;
    default:
      $status = '';
      break;
  }
  $transaction['status'] = $status;

  $status = '';
  switch ($transaction['auth_complete_status']) {
    case PROCESSING_STATUS_AUTH_WINDCAVE:
      $status = 'Processing';
      break;
    case COMPLETED_STATUS_AUTH_WINDCAVE:
      $status = 'Completed';
      break;
    case NOT_COMPLETED_STATUS_AUTH_WINDCAVE:
      $status = 'Not completed';
      break;
    case VOIDED_STATUS_AUTH_WINDCAVE:
      $status = 'Voided';
      break;
    default:
      $status = '';
      break;
  }
  $transaction['auth_complete_status'] = $status;

  $status = '';
  switch ($transaction['refund_status']) {
    case NOT_REFUNDED_STATUS_WINDCAVE:
      $status = 'Not refunded';
      break;
    case REFUNDING_STATUS_WINDCAVE:
      $status = 'Refunding';
      break;
    case REFUND_COMPLETE_STATUS_WINDCAVE:
      $status = 'Refunded';
      break;
    default:
      $status = '';
      break;
  }
  $transaction['refund_status'] = $status;

  $status = '';
  switch ($transaction['void_status']) {
    case NOT_VOIDED_STATUS_WINDCAVE:
      $status = 'Not voided';
      break;
    case VOIDING_STATUS_WINDCAVE:
      $status = 'Voiding';
      break;
    case VOID_COMPLETE_STATUS_WINDCAVE:
      $status = 'Voided';
      break;
    default:
      $status = '';
      break;
  }
  $transaction['void_status'] = $status;

  global $currencies;
  if ( !class_exists('currencies') ) {
    require(DIR_WS_CLASSES . 'currencies.php');
  }
  
  if (!isset($currencies)) {
    $currencies = new currencies();
  }

  // $currency = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '" . $transaction['currency'] . "' limit 1"));
  $transaction['amount'] = $currencies->format($transaction['amount'], false, $transaction['currency']);

  return $transaction;
}

function prepareOrder($transaction)
{
  $order_id = $transaction['order_id'];
  $query = tep_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . $order_id . "' limit 1");

  if ($query->num_rows > 0) {
    $order = tep_db_fetch_array(tep_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . $order_id . "' limit 1"));
    $orders_status = tep_db_fetch_array(tep_db_query("select * from " . TABLE_ORDERS_STATUS . " where orders_status_id = '" . $order['orders_status'] . "' limit 1"));
    $order['orders_status'] = $orders_status['orders_status_name'];
    $order['deleted'] = false;
    $order['inactive'] = false;
  } else {
    $inactive = true;
    $order_transactions = tep_db_query("select * from windcave_transaction where order_id = '" . $order_id . "'");
    for ($i = 0; $i < $order_transactions->num_rows; $i++) {
      $order_transaction = tep_db_fetch_array($order_transactions);
      if (($order_transaction['status'] == APPROVED_STATUS_WINDCAVE) || ($order_transaction['status'] == PROCESSING_STATUS_WINDCAVE)) {
        if (($order_transaction['transaction_type'] == 'purchase'  || $order_transaction['transaction_type'] == 'complete') && $order_transaction['refund_status'] != REFUND_COMPLETE_STATUS_WINDCAVE) {
          $inactive = false;
        } elseif ($order_transaction['transaction_type'] == 'auth' && $order_transaction['void_status'] != VOID_COMPLETE_STATUS_WINDCAVE) {
          $inactive = false;
        }
      }
    }

    $customer = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CUSTOMERS . " where customers_id = '" . $transaction['customer_id'] . "' limit 1"));
    $order = array(
      'deleted' => true,
      'inactive' => $inactive,
      'orders_status' => 'Deleted',
      'orders_id' => $transaction['order_id'],
      'customers_name' => $customer['customers_firstname'] . $customer['customers_lastname']
    );
    if ($transaction['outstanding']) {
      $order['orders_status'] .= ' - OUTSTANDING';
    }
  }

  return $order;
}

function prepareProducts($transaction)
{
  if ($transaction['parent_transaction_id'] != '') {
    $transaction = tep_db_fetch_array(tep_db_query("select * from windcave_transaction where transaction_id = '" . $transaction['parent_transaction_id'] . "' limit 1"));
  }
  $currency = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '" . $transaction['currency'] . "' limit 1"));
  $items = json_decode($transaction['items']);
  $table = '<table border="0" cellspacing="0" cellpadding="0">';
  foreach ($items as $item) {
    $name = tep_db_fetch_array(tep_db_query("select * from " . TABLE_PRODUCTS_DESCRIPTION . " where products_id = '" . $item->id . "' limit 1"))['products_name'];
    $total = tep_db_fetch_array(tep_db_query("select * from " . TABLE_ORDERS_PRODUCTS . " where products_id = '" . $item->id . "' and orders_id = '" . $transaction['order_id'] . "' limit 1"))['final_price'] * $item->qty * $currency['value'];
    $table .= '<tr>';
    $table .= '<td>';
    $table .= $item->qty . 'x ' . $name . ' - ' . $currency['symbol_left'] . $total . $currency['symbol_right'];
    $table .= '</td>';
    $table .= '</tr>';
  }
  $table .= '</table>';

  return $table;
}

function refund($transaction_id, $logger, $refund_remaining, $refund_total)
{
  $logger->addLog('Starting refund');

  $query = tep_db_query("select * from windcave_transaction where transaction_id ='" . $transaction_id . "' limit 1");

  if ($refund_remaining) {
    $refund_total = 0;
  }

  if (!is_numeric($refund_total)) {
    return array(
      'success' => false,
      'message' => 'Error - non-numeric refund amount',
    );
  }

  if ($query->num_rows <= 0) {
    $logger->addLog('Error - could not find transaction to refund');
    return array(
      'success' => false,
      'message' => 'Error - could not find transaction to refund',
    );
  }

  $old_transaction = tep_db_fetch_array($query);
  $amount_left_to_refund = getAmountLeftToRefund($old_transaction);
  if ($refund_remaining) {
    $refund_total = $amount_left_to_refund;
  }

  if (($amount_left_to_refund - $refund_total) < 0) {
    return array(
      'success' => false,
      'message' => 'Error - tried to refund more than the available amount',
    );
  }

  $partial = false;
  if (($refund_total < $old_transaction['amount']) && (($amount_left_to_refund - $refund_total) > 0)) {
    //partial refund
    $partial = true;
    $statuses = array(
      'parent_txn_processing' => REFUNDING_STATUS_WINDCAVE,
      'parent_txn_complete' => NOT_REFUNDED_STATUS_WINDCAVE,
      'parent_txn_previous' => NOT_REFUNDED_STATUS_WINDCAVE
      //oscommerce
    );
  } else {
    //full refund
    $statuses = array(
      'parent_txn_processing' => REFUNDING_STATUS_WINDCAVE,
      'parent_txn_complete' => REFUND_COMPLETE_STATUS_WINDCAVE,
      'parent_txn_previous' => NOT_REFUNDED_STATUS_WINDCAVE
      //oscommerce
    );
  }

  if ($old_transaction['fully_credited'] == 0 && $old_transaction['refund_status'] == NOT_REFUNDED_STATUS_WINDCAVE) {
    $logger->addLog('starting refund for this transaction', 'transaction', $old_transaction['transaction_id']);

    global $currencies;

    if ( !class_exists('currencies') ) {
      require(DIR_WS_CLASSES . 'currencies.php');
    }
    
    if (!isset($currencies)) {
      $currencies = new currencies();
    }

    $decimal_places = $currencies->currencies[$old_transaction['currency']]['decimal_places'];
    // $currency = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '" .  . "' limit 1"));
    $formatted_amount = number_format($refund_total, $decimal_places, '.', '');
 
    $info = array(
      'type' => 'refund',
      'parent_type' => $old_transaction['transaction_type'],
      'parent_id' => $old_transaction['transaction_id'],
      'statuses' => $statuses,
      'amount' => $formatted_amount,
      'currency' => $old_transaction['currency'],
      'merchant_reference' => $old_transaction['order_id'],
      'customer_id' => $old_transaction['customer_id'],
    );

    $transaction = new windcaveTransaction($logger, $info);
    $result = $transaction->startTransaction(array('complete', 'purchase'));
  }

  if ($result['success']) {
    $result['message'] = 'Transaction refunded successfully';
    if (!$partial) {
      tep_db_query("update windcave_transaction set outstanding = '" . false . "' where order_id = '" . $old_transaction['order_id'] . "'");
    }
  } else {
    tep_db_query("update windcave_transaction set status = '" . APPROVED_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
    if ($result['message'] != '') {
      $result['message'] = 'Refund failed - ' . $result['message'];
    } else {
      $result['message'] = 'Refund failed';
    }
  }

  return $result;
}

function void($transaction_id, $logger)
{
  $query = tep_db_query("select * from windcave_transaction where transaction_id = '" . $transaction_id . "' limit 1");
  if ($query->num_rows > 0) {
    $auth_transaction = tep_db_fetch_array($query);
    $statuses = array(
      'parent_txn_processing' => VOIDING_STATUS_WINDCAVE,
      'parent_txn_complete' => VOID_COMPLETE_STATUS_WINDCAVE,
      'parent_txn_previous' => NOT_VOIDED_STATUS_WINDCAVE
      //oscommerce
    );
    if ($auth_transaction['auth_complete_status'] == NOT_COMPLETED_STATUS_AUTH_WINDCAVE) {
      if ($auth_transaction['void_status'] == NOT_VOIDED_STATUS_WINDCAVE) {
        global $currencies;
        if ( !class_exists('currencies') ) {
          require(DIR_WS_CLASSES . 'currencies.php');
        }
        
        if (!isset($currencies)) {
          $currencies = new currencies();
        }
    
        $decimal_places = $currencies->currencies[$auth_transaction['currency']]['decimal_places'];
        $formatted_amount = number_format($auth_transaction['amount'], $decimal_places, '.', '');
    
        $info = array(
          'type' => 'void',
          'parent_type' => $auth_transaction['transaction_type'],
          'parent_id' => $auth_transaction['transaction_id'],
          'statuses' => $statuses,
          'amount' => $formatted_amount,
          'currency' => $auth_transaction['currency'],
          'merchant_reference' => $auth_transaction['order_id'],
          'customer_id' => $auth_transaction['customer_id'],
        );

        $transaction = new windcaveTransaction($logger, $info);
        $result = $transaction->startTransaction(array('auth'));
        if ($result['success']) {
          tep_db_query("update windcave_transaction set auth_complete_status = '" . VOIDED_STATUS_AUTH_WINDCAVE . "' where transaction_id = '" . $auth_transaction['transaction_id'] . "'");
          tep_db_query("update windcave_transaction set outstanding = '" . false . "' where order_id = '" . $auth_transaction['order_id'] . "'");
          $result['message'] = 'Transaction voided successfully';
        } else {
          tep_db_query("update windcave_transaction set status = '" . APPROVED_STATUS_WINDCAVE . "' where transaction_id = '" . $auth_transaction['transaction_id'] . "'");
          if ($result['message'] != '') {
            $result['message'] = 'Void failed - ' . $result['message'];
          } else {
            $result['message'] = 'Void failed';
          }
        }
      } else {
        $logger->addLog("Error - transaction void status was not 'not voided', actual status was: " . $transaction['void_status'], 'transaction', $auth_transaction['transaction_id']);
        $result = array(
          'success' => false,
          'message' => "Error - transaction void status was not 'not voided'"
        );
      }
    } else {
      $logger->addLog("Error - transaction auth complete status was not 'not completed, actual status was: " . $transaction['auth_complete_status'], 'transaction', $auth_transaction['transaction_id']);
      $result = array(
        'success' => false,
        'message' => "Error - transaction auth complete status was not 'not completed'"
      );
    }
  } else {
    $logger->addLog('Error - could not find transaction to void');
    $result = array(
      'success' => false,
      'message' => 'Error - could not find transaction to void'
    );
  }
  return $result;
}

function complete($transaction_id, $logger)
{
  $logger->addLog('Starting complete');

  $query = tep_db_query("select * from windcave_transaction where transaction_id = '" . $transaction_id . "' limit 1");
  if ($query->num_rows > 0) {
    $auth_transaction = tep_db_fetch_array($query);
    $statuses = array(
      'parent_txn_processing' => PROCESSING_STATUS_AUTH_WINDCAVE,
      'parent_txn_complete' => COMPLETED_STATUS_AUTH_WINDCAVE,
      'parent_txn_previous' => NOT_COMPLETED_STATUS_AUTH_WINDCAVE
      //oscommerce
    );
    if ($auth_transaction['auth_complete_status'] == NOT_COMPLETED_STATUS_AUTH_WINDCAVE) {
      global $currencies;
      if ( !class_exists('currencies') ) {
        require(DIR_WS_CLASSES . 'currencies.php');
      }
      
      if (!isset($currencies)) {
        $currencies = new currencies();
      }
  
      $decimal_places = $currencies->currencies[$auth_transaction['currency']]['decimal_places'];
      $formatted_amount = number_format($auth_transaction['amount'], $decimal_places, '.', '');

      $info = array(
        'type' => 'complete',
        'parent_type' => $auth_transaction['transaction_type'],
        'parent_id' => $auth_transaction['transaction_id'],
        'statuses' => $statuses,
        'amount' => $formatted_amount,
        'currency' => $auth_transaction['currency'],
        'merchant_reference' => $auth_transaction['order_id'],
        'customer_id' => $auth_transaction['customer_id'],
      );

      $transaction = new windcaveTransaction($logger, $info);
      $result = $transaction->startTransaction(array('auth'));
      tep_db_query("update windcave_transaction set status = '" . APPROVED_STATUS_WINDCAVE . "' where transaction_id = '" . $auth_transaction['transaction_id'] . "'");
      if ($result['success']) {
        $result['message'] = 'Transaction completed successfully';
      } else {
        if ($result['message'] != '') {
          $result['message'] = 'Complete failed - ' . $result['message'];
        } else {
          $result['message'] = 'Complete failed';
        }
      }
    } else {
      $logger->addLog("Error - transaction auth_complete_status was not 'not complete status' (" . NOT_COMPLETED_STATUS_AUTH_WINDCAVE . "). Actual status was: " . $auth_transaction['auth_complete_status'], 'transaction', $auth_transaction['transaction_id']);
      $result = array(
        'success' => false,
        'message' => "The transaction as not in the correct auth complete state (must be 'not complete')"
      );
    }
  } else {
    $logger->addLog('Error - could not find transaction to complete');
    $result = array(
      'success' => false,
      'message' => 'Error - could not find transaction to complete'
    );
  }
  return $result;
}

function retry($old_transaction, $retry_type, $logger) //, $complete_status_oscommerce
{
  $success = false;
  $message = "";

  $query = tep_db_query("select * from windcave_transaction where parent_transaction_id = '" . $old_transaction['transaction_id'] . "' and transaction_type = '" . $retry_type . "' and status = '" . PROCESSING_STATUS_WINDCAVE . "' limit 1");
  if ($query->num_rows > 0) {
    $retry_transaction = tep_db_fetch_array($query);
    $logger->addLog("uncompleted $retry_type found for this transaction, beginning requery", 'transaction', $old_transaction['transaction_id']);

    $info = array(
      'type' => $retry_type,
      'parent_type' => $old_transaction['transaction_type'],
      'parent_id' => $old_transaction['transaction_id'],
      'statuses' => '',
      'amount' => '',
      'currency' => '',
      'merchant_reference' => '',
      'customer_id' => '',
    );

    $transaction = new windcaveTransaction($logger, $info);
    $result = $transaction->doQuery(0, $old_transaction['session_id'], $retry_transaction['transaction_id']);
    if ($result == "success") {
      $logger->addLog('requery successful, this transaction has been ' . $retry_type . 'ed', 'transaction', $old_transaction['transaction_id']);
      tep_db_query("update windcave_transaction set status = '" . APPROVED_STATUS_WINDCAVE . "' where transaction_id = '" . $retry_transaction['transaction_id'] . "'");
      switch ($retry_type) {
        case 'refund':
          $amount_left_to_refund = getAmountLeftToRefund($old_transaction);
          if ($amount_left_to_refund == 0) {
            tep_db_query("update windcave_transaction set refund_status = '" . REFUND_COMPLETE_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
            tep_db_query("update windcave_transaction set outstanding = '" . false . "' where order_id = '" . $old_transaction['order_id'] . "'");
          } else {
            tep_db_query("update windcave_transaction set refund_status = '" . NOT_REFUNDED_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          }
          break;
        case 'void':
          tep_db_query("update windcave_transaction set void_status = '" . VOID_COMPLETE_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          tep_db_query("update windcave_transaction set outstanding = '" . false . "' where order_id = '" . $old_transaction['order_id'] . "'");
          break;
        case 'complete':
          tep_db_query("update windcave_transaction set auth_complete_status = '" . COMPLETED_STATUS_AUTH_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          break;
      }
      //add order history
    } elseif ($result == "failure") {
      $logger->addLog('requery successful, this transaction has been declined', 'transaction', $retry_transaction['transaction_id']);
      tep_db_query("update windcave_transaction set status = '" . DECLINED_STATUS_WINDCAVE . "' where transaction_id = '" . $retry_transaction['transaction_id'] . "'");
      switch ($retry_type) {
        case 'refund':
            tep_db_query("update windcave_transaction set refund_status = '" . NOT_REFUNDED_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          
          break;
        case 'void':
          tep_db_query("update windcave_transaction set void_status = '" . NOT_VOIDED_STATUS_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          break;
        case 'complete':
          tep_db_query("update windcave_transaction set auth_complete_status = '" . NOT_COMPLETED_STATUS_AUTH_WINDCAVE . "' where transaction_id = '" . $old_transaction['transaction_id'] . "'");
          break;
      }
    } else {
      $logger->addLog('requery unsuccessful, this transaction has not been ' . $retry_type . 'ed', 'transaction', $old_transaction['transaction_id']);
    }
  } else {
    $logger->addLog("attempted to requery the $retry_type for this transaction, but no child $retry_type transaction exists", 'transaction', $old_transaction['transaction_id']);
    $message = "No processing child $retry_type transaction exists";
  }
  return array(
    'success' => $success == "success",
    'message' => $message
  );
}
function getAmountLeftToRefund($transaction)
{
  $amount_left_to_refund = $transaction['amount'];
  $refund_transactions_query = tep_db_query("select * from windcave_transaction where parent_transaction_id = '" . $transaction['transaction_id'] . "' and transaction_type = 'refund'");
  for ($i = 0; $i < $refund_transactions_query->num_rows; $i++) {
    $refund_transaction = tep_db_fetch_array($refund_transactions_query);
    if ($refund_transaction['status'] == APPROVED_STATUS_WINDCAVE) {
      $amount_left_to_refund -= $refund_transaction['amount'];
    }
  }
  return $amount_left_to_refund;
}
?>
<script>
  $("#form-transaction").one('submit', function(e) {
    e.preventDefault();
  });

  function buttonClick(action) {
    //$(this).find('button').attr('disabled','disabled');
    var buttons = document.querySelectorAll('button');
    var i = 0;
    for (i = 0; i < buttons.length; i++) {
      buttons[i].disabled = true;
    }
    var form = document.getElementById("form-transaction");
    form.action = form.action + '&action=' + action;
    form.submit();
  }
</script>