<?php
global $cart, $customer_id, $language, $currency;
chdir('../../../../');

require('includes/application_top.php');

require('ext/modules/payment/windcave/constants.php');
require('ext/modules/payment/windcave/classes/windcave_filelock.php');
require('ext/modules/payment/windcave/classes/windcave_entity.php');
require('ext/modules/payment/windcave/classes/windcave_session.php');
require('ext/modules/payment/windcave/classes/windcave_logger.php');
require('ext/modules/payment/windcave/constants.php');
require(DIR_WS_CLASSES . 'order.php');

global $currency;

$currency_to_use = $currency;
if (is_array($currency_to_use)) {
    $currency_to_use = $currency['code'];
}

$logger = new windcaveLogger(MODULE_PAYMENT_WINDCAVE_DIR_LOG);

$logger->addLog('windcave checkout script invoked');

$iframe = (MODULE_PAYMENT_WINDCAVE_IFRAME == 'True');
$get_vars = $HTTP_GET_VARS['data'];

$order_id = $get_vars['order_id'];

$store_card = false;

$use_saved_card = isset($get_vars['use_saved_card']) ? ($get_vars['use_saved_card'] == 1) : false;
$save_card = isset($get_vars['save_card']) ? $get_vars['save_card'] == "on" : false;
if ($use_saved_card) {
    $card_id = isset($get_vars['card_id']) ? $get_vars['card_id'] : false;
    $stored_card_indicator = 'credentialonfile';
} else {
    $store_card = $save_card;
    if ($store_card) {
        $stored_card_indicator = 'credentialonfileinitial';
    }
}

// $currency = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '" . $currency . "' limit 1"));
$currency_value = $currencies->get_value($currency_to_use);
$currency_decimal_places = $currencies->get_decimal_places($currency_to_use);

$formattedAmount = number_format($get_vars['amount'] * $currency_value, $currency_decimal_places, '.', '');

$info = array(
    'type' => strtolower(MODULE_PAYMENT_WINDCAVE_TRANSACTION_TYPE),
    'amount' => $formattedAmount,
    'currency' => $currency_to_use,
    'merchant_reference' => $order_id,
    'methods' => prepareMethods(),
    'card_id' => isset($card_id) ? $card_id : '',
    'language' => tep_db_fetch_array(tep_db_query('select * from ' . TABLE_LANGUAGES . " where directory = '" . $language . "' limit 1"))['code'],
    'store_card' => $store_card,
    'stored_card_indicator' => $stored_card_indicator,
    'customer' => prepareCustomer($order_id),
    'order_id' => $order_id
);

$session = new windcaveSession($logger, true, $info);

$transaction = tep_db_fetch_array(tep_db_query("select * from windcave_transaction where order_id = '" . $order_id . "' limit 1"));

if ($transaction['transaction_id'] != null) {
    echo json_encode(array('success' => true, 'url' => tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'), 'iframe' => false));
}

$result = $session->createSession();
$success = $result['success'];



if ($success) {
    if (isset($result['session_id'])) {
        $session_item = tep_db_fetch_array(tep_db_query("select session_state from windcave_session where session_id = '" . $result['session_id'] . "' limit 1"));
        if ($session_item['session_state'] == 'pending') {
            echo json_encode(array('success' => true, 'url' => $result['url'], 'iframe' => $get_vars['iframe']));
            return;
        } else {
            $transaction = tep_db_fetch_array(tep_db_query("select * from windcave transaction where session_id = '" . $result['session_id'] . "' limit 1"));
            if ($transaction['status'] == APPROVED_STATUS_WINDCAVE) {
                echo json_encode(array('success' => true, 'url' => tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'), 'iframe' => false));
            } else {
                echo json_encode(array('success' => true, 'url' => tep_href_link(FILENAME_CHECKOUT_SHIPPING, 'error_message=Error', 'SSL'), 'iframe' => false));
            }
        }
    } else {
        echo json_encode(array('success' => true, 'url' => tep_href_link(FILENAME_CHECKOUT_SHIPPING, 'error_message=Error', 'SSL'), 'iframe' => false));
    }
} else {
    $wc_order_status_id = defined('MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID') && ((int) MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID > 0) ? (int) MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID : 0;
    $order_status_query = tep_db_query("select orders_status_history_id from " . TABLE_ORDERS_STATUS_HISTORY . " where orders_id = '" . (int)$order_id . "' and orders_status_id = '" . (int)$wc_order_status_id . "' and comments = '' order by date_added desc limit 1");

    if (tep_db_num_rows($order_status_query)) {
      $order_status = tep_db_fetch_array($order_status_query);

      $sql_data_array = array('comments' => 'Failed to generate payment session.');

      tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array, 'update', "orders_status_history_id = '" . (int)$order_status['orders_status_history_id'] . "'");
    }

    echo json_encode(array('success' => true, 'url' => tep_href_link(FILENAME_CHECKOUT_SHIPPING, 'error_message=Could not connect to payment gateway', 'SSL'), 'iframe' => false));
}

function prepareCustomer($order_id)
{
    $order = tep_db_fetch_array(tep_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . $order_id . "' limit 1"));
    $customer_query = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CUSTOMERS . " where customers_id = '" . $order['customers_id'] . "' limit 1"));

    $country_code = tep_db_fetch_array(tep_db_query("select * from " . TABLE_COUNTRIES . " where countries_name = '" . $order['delivery_country'] . "' limit 1"))['countries_iso_code_2'];
    $shipping = array(
        'name' => $order['delivery_name'],
        'address1' => $order['delivery_street_address'],
        'address2' => $order['delivery_suburb'],
        //'address3' => $order['delivery_name'],
        'city' => $order['delivery_city'],
        'countryCode' => $country_code,
        'postalCode' => $order['delivery_postcode'],
        'phoneNumber' => $customer_query['customers_telephone']
        // 'state' => $order['delivery_state']
    );
    $country_code = tep_db_fetch_array(tep_db_query("select * from " . TABLE_COUNTRIES . " where countries_name = '" . $order['shipping_country'] . "' limit 1"))['countries_iso_code_2'];
    $billing = array(
        'name' => $order['billing_name'],
        'address1' => $order['billing_street_address'],
        'address2' => $order['billing_suburb'],
        //'address3' => $order['billing_name'],
        'city' => $order['billing_city'],
        'countryCode' => $country_code,
        'postalCode' => $order['billing_postcode'],
        'phoneNumber' => $customer_query['customers_telephone']
        // 'state' => $order['billing_state'],
    );
    foreach ($shipping as $key => $value) {
        if (!isset($shipping[$key])) {
            $shipping[$key] = " ";
        }
    }
    foreach ($billing as $key => $value) {
        if (!isset($billing[$key])) {
            $billing[$key] = " ";
        }
    }
    $customer = array(
        'firstName' => $customer_query['customers_firstname'],
        'lastName' => $customer_query['customers_lastname'],
        'email' => $customer_query['customers_email_address'],
        'phoneNumber' => $customer_query['customers_telephone'],
        'account' => $order['customers_id'],
        'shipping' => $shipping,
        'billing' => $billing,
    );
    foreach ($customer as $key => $value) {
        if (!isset($customer[$key])) {
            $customer[$key] = " ";
        }
    }
    return $customer;
}

function prepareMethods()
{
    $methods_query = tep_db_query("select configuration_key, configuration_value from " . TABLE_CONFIGURATION . " where configuration_key like '%MODULE_PAYMENT_WINDCAVE_METHOD_%'");
    $methods = array();
    for ($i = 0; $i < $methods_query->num_rows; $i++) {
        $method = tep_db_fetch_array($methods_query);
        if ($method['configuration_value'] == 'Enabled') {
            $method_key = $method['configuration_key'];
            $methods[] = strtolower(str_replace(substr($method_key, 0, 31), '', $method_key));
        }
    }
    return $methods;
}
