<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2014 osCommerce

  Released under the GNU General Public License
*/

class windcave
{
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function windcave()
    {

        $this->signature = 'windcave|windcave|1.0|2.3';

        $this->code = 'windcave';
        $this->group = 'account';

        $this->title = MODULE_CONTENT_ACCOUNT_WINDCAVE_TEXT_TITLE;
        $this->description = MODULE_CONTENT_ACCOUNT_WINDCAVE_TEXT_DESCRIPTION;

        if (defined('MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS')) {
            $this->sort_order = MODULE_CONTENT_ACCOUNT_WINDCAVE_SORT_ORDER;
            $this->enabled = (MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS == 'True');
        }

        $this->public_title = MODULE_CONTENT_ACCOUNT_WINDCAVE_TEXT_PUBLIC_TITLE;
         if ( !(defined('MODULE_PAYMENT_INSTALLED') && tep_not_null(MODULE_PAYMENT_INSTALLED) && in_array('windcave.php', explode(';', MODULE_PAYMENT_INSTALLED))) ) {
             $this->enabled = false;
         }
    }

    function execute()
    {
        global $oscTemplate;

        $oscTemplate->_data['account']['account']['links']['windcave_cards'] = array(
            'title' => 'Windcave saved cards',
            'link' => tep_href_link('ext/modules/payment/windcave/saved_cards.php', '', 'SSL'),
            'icon' => 'newwin'
        );
        $oscTemplate->_data['account']['account']['links']['windcave_orders'] = array(
            'title' => 'Windcave pending orders',
            'link' => tep_href_link('ext/modules/payment/windcave/pending_orders.php', '', 'SSL'),
            'icon' => 'newwin'
        );
    }

    function isEnabled()
    {
        return $this->enabled;
    }

    function check()
    {
        return defined('MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS');
    }

    function install()
    {
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Windcave User Interface', 'MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS', 'True', 'Do you want to enable the Windcave User Interface Module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_ACCOUNT_WINDCAVE_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove()
    {
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys()
    {
        return array('MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS', 'MODULE_CONTENT_ACCOUNT_WINDCAVE_SORT_ORDER');
    }
}
