<?php


class windcave
{
    var $code, $title, $description, $enabled;

    function windcave()
    {
        global $HTTP_GET_VARS, $PHP_SELF, $order, $payment;


        $this->signature = 'windcave|windcave|1.0|2.3';


        $this->code = 'windcave';
        $this->title = MODULE_PAYMENT_WINDCAVE_TEXT_TITLE;
        $this->public_title = MODULE_PAYMENT_WINDCAVE_TEXT_PUBLIC_TITLE;
        $this->description = MODULE_PAYMENT_WINDCAVE_TEXT_DESCRIPTION;
        $this->sort_order = defined('MODULE_PAYMENT_WINDCAVE_SORT_ORDER') ? MODULE_PAYMENT_WINDCAVE_SORT_ORDER : 0;
        $this->enabled = defined('MODULE_PAYMENT_WINDCAVE_STATUS') && (MODULE_PAYMENT_WINDCAVE_STATUS == 'True') ? true : false;
        $this->order_status = defined('MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID') && ((int) MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID > 0) ? (int) MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID : 0;

        if (!function_exists('curl_init')) {
            $this->description = '<div class="secWarning">' . MODULE_PAYMENT_WINDCAVE_ERROR_ADMIN_CURL . '</div>' . $this->description;

            $this->enabled = false;
        }

        if (is_object($order)) $this->update_status();
    }

    function update_status()
    {
        global $order;

        if (($this->enabled == true) && ((int) MODULE_PAYMENT_WINDCAVE_ZONE > 0)) {
            $check_flag = false;
            $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WINDCAVE_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
            while ($check = tep_db_fetch_array($check_query)) {
                if ($check['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
                    $check_flag = true;
                    break;
                }
            }

            if ($check_flag == false) {
                $this->enabled = false;
            }
        }

        if (is_object($order)) {
            if ($order->info['total'] <= 0 || $order->info['total'] < MODULE_PAYMENT_WINDCAVE_MIN_TOTAL) {
                $this->enabled = false;
            }
        }
    }

    function javascript_validation()
    {
        return false;
    }

    function selection()
    {
        return array(
            'id' => $this->code,
            'module' => $this->title
        );
    }

    function pre_confirmation_check()
    {
        global $cartID, $cart;

        if (empty($cart->cartID)) {
            $cartID = $cart->cartID = $cart->generate_cart_id();
        }

        if (!tep_session_is_registered('cartID')) {
            tep_session_register('cartID');
        }
    }

    function confirmation()
    {
        global $order, $customer_id;

        $content = '';
        $content .= '<style>';
        $content .= '   #overlay {';
        $content .= '      position: fixed;';
        $content .= '      display: none;';
        $content .= '      top: 0;';
        $content .= '      left: 0;';
        $content .= '      right: 0;';
        $content .= '      bottom: 0;';
        $content .= '      background-color: rgba(0,0,0,0.5);';
        $content .= '      z-index: 9998;';
        $content .= '      cursor: pointer;';
        $content .= '   }';
        $content .= '   .windcave-iframe {';
        $content .= '      height:100%;';
        $content .= '      width:100%;';
        $content .= '   }';
        $content .= '   .windcave-iframe-container {';
        $content .= '      background-color: rgba(255,255,255,255);';
        $content .= '      z-index:9999;';
        $content .= '      height:' . MODULE_PAYMENT_WINDCAVE_IFRAME_HEIGHT . 'px;';
        $content .= '      width:' . MODULE_PAYMENT_WINDCAVE_IFRAME_WIDTH . 'px;';
        $content .= '      text-align:center;';
        $content .= '      background: white none repeat scroll 0% 0%;';
        $content .= '   }';
        $content .= '</style>';
        $content .= '<div id="overlay">';
        $content .= '   <table border="0" width="100%" height="100%">';
        $content .= '       <tr><td>&nbsp;</td></tr>';
        $content .= '       <tr>';
        $content .= '           <td>';
        $content .= '               &nbsp;';
        $content .= '           </td>';
        $content .= '           <td id="windcave-iframe-container" class="windcave-iframe-container">';
        $content .= '           </td>';
        $content .= '           <td>';
        $content .= '               &nbsp;';
        $content .= '           </td>';
        $content .= '       </tr>';
        $content .= '       <tr><td>&nbsp;</td></tr>';
        $content .= '   </table>';
        $content .= '</div>';
        $content .= '<script>' . "\n";
        $content .= '   function iframeOn(url){' . "\n";
        $content .= '      document.getElementById("overlay").style.display = "block";' . "\n";
        $content .= '      var new_iframe = document.createElement("iframe");';
        $content .= '      new_iframe.setAttribute(*class*,*windcave-iframe*);' . "\n";
        $content .= '      new_iframe.setAttribute(*frameborder*,"0");' . "\n";
        $content .= '      new_iframe.setAttribute(*allowpaymentrequest*,"");' . "\n";
        $content .= '      new_iframe.src = url;' . "\n";
        $content .= '      new_iframe.id = *windcave-iframe*;';
        $content .= '      var iframe_container = document.getElementById("windcave-iframe-container");';
        $content .= '      iframe_container.appendChild(new_iframe);';
        $content .= '      var iframe = document.getElementById("windcave-iframe");';
        $content .= '      var iframeDocument = iframe.contentWindow;' . "\n";
        $content .= '      iframe.onload = function() {' . "\n";
        $content .= '          try {';
        $content .= '              iframeDocument.location.href;' . "\n";
        $content .= '              var element = iframeDocument.document.getElementById("return-url");' . "\n";
        $content .= '              window.top.location.href = element.name;' . "\n";
        $content .= '              } catch(e) {' . "\n";
        $content .= '              }' . "\n";
        $content .= '      }' . "\n";
        $content .= '   }' . "\n";
        $content .= '</script>' . "\n";
        $content .= '<script>';
        $content .= "   $('form').one('submit', function(e){";
        $content .= '   e.preventDefault();';
        $content .= '   $(this).find(*button[type="submit"]*).attr("disabled","disabled");';
        $content .= '   var form = $(this);';
        $content .= '   var url = form.attr("action");';
        $content .= '   var to_send = (form.serializeArray());';
        $content .= '   $.ajax({';
        $content .= '       type: *POST*,';
        $content .= '       url: url,';
        $content .= '       dataType: *JSON*,';
        $content .= '       data: {data:to_send},';
        $content .= '       success: function(data)';
        $content .= '       {';
        $content .= '          if(data.iframe == 1){';
        $content .= '              iframeOn(data.url)';
        $content .= '          }';
        $content .= '          else{';
        $content .= '              window.location.href = data.url;';
        $content .= '          }';
        $content .= '       }';
        $content .= '      });';
        $content .= '   });';
        $content .= '</script>';

        $content = str_replace('*', "'", $content);

        if (MODULE_PAYMENT_WINDCAVE_IFRAME == "True") {
            $iframe = 1;
        } else {
            $iframe = 0;
        }

        $confirmation = array(
            'title' => $content,
            'fields' => array(
                array(
                    'title' => '',
                    'field' => tep_draw_hidden_field('amount', $order->info['total'])
                ),
                array(
                    'title' => '',
                    'field' => tep_draw_hidden_field('currency', $order->info['currency'])
                ),
                array(
                    'title' => '',
                    'field' => tep_draw_hidden_field('iframe', $iframe)
                ),
            )
        );
        if (tep_session_is_registered('customer_id') && MODULE_PAYMENT_WINDCAVE_SAVE_CARDS == "True") {
            $query = tep_db_query("select * from windcave_saved_card where customer_id = '" . $customer_id . "'");
            if ($query->num_rows > 0) {
                $saved_cards = array();
                for ($i = 0; $i < $query->num_rows; $i++) {
                    $card = tep_db_fetch_array($query);
                    $saved_cards[$i]['text'] = $card['card_mask'] . "  Exp:" . $card['expiry_date_month'] . "/" . $card['expiry_date_year'];
                    $saved_cards[$i]['id'] = $card['card_id'];
                }
                $confirmation['fields'][] = array(
                    'title' => 'Use saved card',
                    'field' => tep_draw_radio_field('use_saved_card', true, false) . '&nbsp;' .  tep_draw_pull_down_menu('card_id', $saved_cards, $saved_cards[0])
                );
                $confirmation['fields'][] = array(
                    'title' => 'Proceed without using saved card',
                    'field' => tep_draw_radio_field('use_saved_card', false, true) . '&nbsp; Save card' . tep_draw_checkbox_field('save_card')
                );
            } else {
                $confirmation['fields'][] = array(
                    'title' => 'Save card',
                    'field' => tep_draw_checkbox_field('save_card')
                );
            }
        }


        return $confirmation;
    }

    function process_button()
    {
        return false;
    }

    function before_process()
    {
        return false;
    }

    function after_process()
    {
        global $insert_id;



        $post_vars = array();
        foreach ($_POST['data'] as $var) {
            $post_vars[$var['name']] = $var['value'];
        }
        $get_data = array(
            'test' => '',
            'amount' => $post_vars['amount'],
            'currency' => $post_vars['currency'],
            'use_saved_card' => $post_vars['use_saved_card'],
            'save_card' => $post_vars['save_card'],
            'card_id' => $post_vars['card_id'],
            'iframe' => $post_vars['iframe'],
            'order_id' => $insert_id
        );
        $query = http_build_query(array('data' => $get_data));
        tep_redirect(tep_href_link('ext/modules/payment/windcave/checkout.php', 'data=' . $query . '', 'SSL'));
    }

    function get_error()
    {
        return false;
    }

    function check()
    {
        if (!isset($this->_check)) {
            $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WINDCAVE_STATUS'");
            $this->_check = tep_db_num_rows($check_query);
        }
        return $this->_check;
    }

    function install($parameter = null)
    {
        $params = $this->getParams();

        $this->setParams($params, $parameter);

        if (tep_db_num_rows(tep_db_query("show tables like 'windcave_transaction'")) != 1) {
            $sql = <<<EOD
                CREATE TABLE IF NOT EXISTS windcave_transaction (
                    windcave_transaction_id INT(10) NOT NULL AUTO_INCREMENT,
                    order_id                INT(10) NOT NULL,
                    transaction_id          VARCHAR(21) NOT NULL,
                    parent_transaction_id   VARCHAR(16),
                    transaction_type        VARCHAR(16) NOT NULL,
                    amount decimal(15,4)    NOT NULL,
                    currency                CHAR(3) NOT NULL,
                    status                  TINYINT,
                    card_mask               VARCHAR(16),
                    cardholder_name         VARCHAR(32),
                    expiry_date_month       INT(2),
                    expiry_date_year        INT(2),
                    card_type               VARCHAR(16),
                    response_code           VARCHAR(2),
                    response_text           VARCHAR(32),
                    payment_method          VARCHAR(16),
                    payment_authentication  VARCHAR(16),
                    auth_code               VARCHAR(16),
                    avs_result              VARCHAR(32),
                    avs_action              VARCHAR(16),
                    cvc2_result             CHAR(1),
                    risk_action             VARCHAR(16),
                    risk_summary_text       VARCHAR(32),
                    auth_complete_status    TINYINT,
                    refund_status           TINYINT,
                    void_status             TINYINT,
                    store_card              TINYINT,
                    customer_id             VARCHAR(10),
                    date_added              DATETIME NOT NULL,
                    session_id              VARCHAR(32),
                    fully_credited          BOOLEAN,
                    card_id                 VARCHAR(16),
                    hpp_link                VARCHAR(1024),
                    processed_by            VARCHAR(16),
                    order_totals            VARCHAR(2048),
                    items                   VARCHAR(2048),
                    outstanding             BOOLEAN,
                    INDEX (order_id),
                    INDEX (transaction_id),
                    INDEX (session_id),
                    PRIMARY KEY (windcave_transaction_id)
                 );     
EOD;

            tep_db_query($sql);
        }
        if (tep_db_num_rows(tep_db_query("show tables like 'windcave_session'")) != 1) {
            $sql = <<<EOD
            CREATE TABLE IF NOT EXISTS windcave_session (
                id INT(10)              NOT NULL AUTO_INCREMENT,
                session_id              VARCHAR(32) NOT NULL,
                session_state           VARCHAR(16) NOT NULL,
                windcave_id                INT(10),
                date_added              DATETIME NOT NULL,
                INDEX(session_id),
                PRIMARY KEY (id)
            );   
EOD;

            tep_db_query($sql);
        }
        if (tep_db_num_rows(tep_db_query("show tables like 'windcave_saved_card'")) != 1) {
            $sql = <<<EOD
            CREATE TABLE IF NOT EXISTS windcave_saved_card (
                id                      INT(10) NOT NULL AUTO_INCREMENT,
                customer_id             INT(10) NOT NULL,
                card_id                 VARCHAR(16) NOT NULL,
                card_mask               VARCHAR(16) NOT NULL,
                expiry_date_month       INT(2),
                expiry_date_year        INT(2),
                INDEX(card_id),
                INDEX(customer_id),
                PRIMARY KEY (id)
            );  
EOD;

            tep_db_query($sql);
        }
        if (tep_db_num_rows(tep_db_query("show tables like 'windcave_stored_cart'")) != 1) {
            $sql = <<<EOD
            CREATE TABLE IF NOT EXISTS windcave_stored_cart (
                id                      INT(10) NOT NULL AUTO_INCREMENT,
                session_id              VARCHAR(32) NOT NULL,
                contents                VARCHAR(2048) NOT NULL,
                INDEX(session_id),
                PRIMARY KEY (id)
            );  
EOD;

            tep_db_query($sql);
        }



        $modules_installed = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_CONTENT_INSTALLED'"));
        $config_value = $modules_installed['configuration_value'];
        if (strpos($config_value, 'account/windcave') === false) {
            $config_value = $config_value . ';account/windcave';
            tep_db_query("update " . TABLE_CONFIGURATION . " set configuration_value = '" . $config_value . "' where configuration_key = 'MODULE_CONTENT_INSTALLED'");
        };

        $ui_params = $this->getUIParams();

        $this->setParams($ui_params, $parameter);
    }

    function setParams($params, $parameter)
    {
        if (isset($parameter)) {
            if (isset($params[$parameter])) {
                $params = array($parameter => $params[$parameter]);
            } else {
                $params = array();
            }
        }
        $methods = array();
        foreach ($params as $key => $data) {
            $sql_data_array = array(
                'configuration_title' => $data['title'],
                'configuration_key' => $key,
                'configuration_value' => (isset($data['value']) ? $data['value'] : ''),
                'configuration_description' => $data['desc'],
                'configuration_group_id' => '6',
                'sort_order' => '0',
                'date_added' => 'now()'
            );

            if (isset($data['set_func'])) {
                $sql_data_array['set_function'] = $data['set_func'];
            }

            if (isset($data['use_func'])) {
                $sql_data_array['use_function'] = $data['use_func'];
            }

            tep_db_perform(TABLE_CONFIGURATION, $sql_data_array);

            if (isset($data['value'])) {
                if ($data['value'] == 'Enabled') {
                    $method = strtolower(str_replace(substr($data['key'], 0, 24), '', $data['key']));
                    $methods[] = $method;
                }
            }
        }
    }
    function remove()
    {
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->UIkeys()) . "')");
        //tep_db_query("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Windcave [Transactions]'  or orders_status_name = 'Preparing [Windcave]'");

        $modules_installed = tep_db_fetch_array(tep_db_query("select * from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_CONTENT_INSTALLED'"));
        $config_value = $modules_installed['configuration_value'];
        $config_value = str_replace('account/windcave', '', $config_value);

        tep_db_query("update " . TABLE_CONFIGURATION . " set configuration_value = '" . $config_value . "' where configuration_key = 'MODULE_CONTENT_INSTALLED'");


        $sql = <<<EOD
            DROP TABLE IF EXISTS windcave_transaction;
EOD;
        tep_db_query($sql);
        $sql = <<<EOD
            DROP TABLE IF EXISTS windcave_session;
EOD;
        tep_db_query($sql);
        $sql = <<<EOD
            DROP TABLE IF EXISTS windcave_saved_card;
EOD;
        tep_db_query($sql);
        $sql = <<<EOD
            DROP TABLE IF EXISTS windcave_stored_cart;
EOD;
        tep_db_query($sql);

        $dir = str_replace('\admin', '', getcwd()) . "/ext/modules/payment/windcave/";

        $windcave_files = scandir($dir);

        foreach ($windcave_files as $filename) {
            if (strpos($filename, 'windcave_session') !== false) {
                //unlink($filename);
                array_map('unlink', glob($dir . $filename));
            }
        }
    }

    function keys()
    {
        $keys = array_keys($this->getParams());
        foreach ($keys as $key) {
            if (!defined($key)) {
                $this->install($key);
            }
        }
        return $keys;
    }

    function UIkeys()
    {
        $keys = array_keys($this->getUIParams());
        foreach ($keys as $key) {
            if (!defined($key)) {
                $this->install($key);
            }
        }
        return $keys;
    }

    function getParams()
    {
        if (!defined('MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID')) {
            $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [Windcave]' limit 1");

            if (tep_db_num_rows($check_query) < 1) {
                $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
                $status = tep_db_fetch_array($status_query);

                $status_id = $status['status_id'] + 1;

                $languages = tep_get_languages();

                foreach ($languages as $lang) {
                    tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $lang['id'] . "', 'Preparing [Windcave]')");
                }

                $flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
                if (tep_db_num_rows($flags_query) == 1) {
                    tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 0 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
                }
            } else {
                $check = tep_db_fetch_array($check_query);

                $status_id = $check['orders_status_id'];
            }
        } else {
            $status_id = MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID;
        }

        if (!defined('MODULE_PAYMENT_WINDCAVE_TRANSACTION_ORDER_STATUS_ID')) {
            $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Windcave [Transactions]' limit 1");

            if (tep_db_num_rows($check_query) < 1) {
                $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
                $status = tep_db_fetch_array($status_query);

                $txn_status_id = $status['status_id'] + 1;

                $languages = tep_get_languages();

                foreach ($languages as $lang) {
                    tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $txn_status_id . "', '" . $lang['id'] . "', 'Windcave [Transactions]')");
                }

                $flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
                if (tep_db_num_rows($flags_query) == 1) {
                    tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 0 and downloads_flag = 0 where orders_status_id = '" . $txn_status_id . "'");
                }
            } else {
                $check = tep_db_fetch_array($check_query);

                $txn_status_id = $check['orders_status_id'];
            }
        } else {
            $txn_status_id = MODULE_PAYMENT_WINDCAVE_TRANSACTION_ORDER_STATUS_ID;
        }

        $params = array(
            'MODULE_PAYMENT_WINDCAVE_STATUS' => array(
                'title' => 'Enable Windcave Payment Module',
                'desc' => '',
                'value' => 'True',
                'set_func' => 'tep_cfg_select_option(array(\'True\', \'False\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_SAVE_CARDS' => array(
                'title' => 'Enable Saving Cards',
                'desc' => 'When enabled, customer cards will be saved',
                'value' => 'True',
                'set_func' => 'tep_cfg_select_option(array(\'True\', \'False\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_API_USERNAME' => array(
                'title' => 'API Username',
                'desc' => ''
            ),
            'MODULE_PAYMENT_WINDCAVE_API_KEY' => array(
                'title' => 'API Key',
                'desc' => ''
            ),
            'MODULE_PAYMENT_WINDCAVE_API_URL' => array(
                'title' => 'API Url',
                'desc' => ''
            ),
            'MODULE_PAYMENT_WINDCAVE_SESSION_TIMEOUT' => array(
                'title' => 'Session timeout (hours)',
                'desc' => 'The length of time a customer has to complete a payment before it is automatically declined'
            ),
            'MODULE_PAYMENT_WINDCAVE_TRANSACTION_TYPE' => array(
                'title' => 'Transaction Type',
                'desc' => '',
                'value' => 'Purchase',
                'set_func' => 'tep_cfg_select_option(array(\'Purchase\', \'Auth\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_IFRAME' => array(
                'title' => 'Display Payment Window as iFrame',
                'desc' => 'When enabled, the payment page will appear in an iFrame',
                'value' => 'False',
                'set_func' => 'tep_cfg_select_option(array(\'True\', \'False\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_IFRAME_HEIGHT' => array(
                'title' => 'iFrame Height',
                'desc' => 'iFrame height in px'
            ),
            'MODULE_PAYMENT_WINDCAVE_IFRAME_WIDTH' => array(
                'title' => 'iFrame Width',
                'desc' => 'iFrame width in px'
            ),
            'MODULE_PAYMENT_WINDCAVE_DIR_LOG' => array(
                'title' => 'Error Log Directory',
                'desc' => 'Error Log Directory'
            ),
            'MODULE_PAYMENT_WINDCAVE_PREPARE_ORDER_STATUS_ID' => array(
                'title' => 'Set Preparing Order Status',
                'desc' => 'Set the status of orders being made with this payment module to this value',
                'value' => $status_id,
                'set_func' => 'tep_cfg_pull_down_order_statuses(',
                'use_func' => 'tep_get_order_status_name'
            ),
            'MODULE_PAYMENT_WINDCAVE_ORDER_STATUS_ID' => array(
                'title' => 'Set Windcave Acknowledged Order Status',
                'desc' => 'Set the status of orders made with this payment module to this value',
                'value' => '0',
                'set_func' => 'tep_cfg_pull_down_order_statuses(',
                'use_func' => 'tep_get_order_status_name'
            ),
            'MODULE_PAYMENT_WINDCAVE_TRANSACTION_ORDER_STATUS_ID' => array(
                'title' => 'Transaction Order Status',
                'desc' => 'Include transaction information in this order status level',
                'value' => $txn_status_id,
                'set_func' => 'tep_cfg_pull_down_order_statuses(',
                'use_func' => 'tep_get_order_status_name'
            ),
            'MODULE_PAYMENT_WINDCAVE_ZONE' => array(
                'title' => 'Payment Zone',
                'desc' => 'If a zone is selected, only enable this payment method for that zone.',
                'value' => '0',
                'use_func' => 'tep_get_zone_class_title',
                'set_func' => 'tep_cfg_pull_down_zone_classes('
            ),
            'MODULE_PAYMENT_WINDCAVE_MIN_TOTAL' => array(
                'title' => 'Minimum Order Total',
                'desc' => 'If the order total is below this, the Windcave Payment Module will not be available',
                'value' => $min_total
            ),
            'MODULE_PAYMENT_WINDCAVE_SORT_ORDER' => array(
                'title' => 'Sort order of display',
                'desc' => 'Sort order of display. Lowest is displayed first.',
                'value' => '0'
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_CARD' => array(
                'title' => 'Card',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_ACCOUNT2ACCOUNT' => array(
                'title' => 'Account 2 account',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_ALIPAY' => array(
                'title' => 'Alipay',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_APPLEPAY' => array(
                'title' => 'Apple Pay',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_GOOGLEPAY' => array(
                'title' => 'Google Pay',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_PAYPAL' => array(
                'title' => 'Paypal',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_INTERAC' => array(
                'title' => 'Interac',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_UNIONPAY' => array(
                'title' => 'UnionPay',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_HUMM' => array(
                'title' => 'Humm',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_VISACHECKOUT' => array(
                'title' => 'Visa Checkout',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),
            'MODULE_PAYMENT_WINDCAVE_METHOD_WECHAT' => array(
                'title' => 'WeChat Pay',
                'desc' => '',
                'value' => 'Disabled',
                'set_func' => 'tep_cfg_select_option(array(\'Enabled\', \'Disabled\'), '
            ),


        );
        return $params;
    }

    function getUIParams()
    {
        $params = array(
            'MODULE_CONTENT_ACCOUNT_WINDCAVE_STATUS' => array(
                'title' => 'Enable Windcave Payment Module',
                'desc' => '',
                'value' => 'True',
                'set_func' => 'tep_cfg_select_option(array(\'True\', \'False\'), '
            ),
            'MODULE_CONTENT_ACCOUNT_WINDCAVE_ZONE' => array(
                'title' => 'Payment Zone',
                'desc' => 'If a zone is selected, only enable this payment method for that zone.',
                'value' => '0',
                'use_func' => 'tep_get_zone_class_title',
                'set_func' => 'tep_cfg_pull_down_zone_classes('
            ),
            'MODULE_CONTENT_ACCOUNT_WINDCAVE_SORT_ORDER' => array(
                'title' => 'Sort order of display',
                'desc' => 'Sort order of display. Lowest is displayed first.',
                'value' => '0'
            ),

        );
        return $params;
    }
}
